searchNodes=[{"doc":"Library for simple and comfortable working with table data. This library implements API for generate and manipulate data Example Firstly, You have to make a DataProvider implementation module, like: defmodule MyDataLoadModule do # Change current module declaration with `DataProvider` use DataProvider # Function which required to return Repo implementation if you # plan to return `Ecto.Query` in `find/1`. # If your `find/1` gonna return not a `Ecto.Query` then defining # `repo/0` have no make sense. def repo ( ) , do : MyRepo # Searching logic, receives `DataProvider` and have to return `Ecto.Query` or `list()` # This function have to implement only searching, with no orders, offsets and limits. def find ( % DataProvider { search_options : % _ { options : %{ &quot;title&quot; =&gt; title } } ) , do : Ecto.Query . from ( p in Posts , where : p . title == ^ title ) def find ( % DataProvider { } ) , do : Ecto.Query . from ( p in Posts ) end When you declared your DataProvider implementation, you can use it as adapter for manipulate data. defmodule MyController do use MyAppWeb , :controller import DataProvider def index ( % Plug.Conn { query_params : query_params , path_params : path_params } = conn , _params ) do # Getting a custom user filtering params (it have to be map). By default, # `DataProvider` already contain initial state of searching # options (they are empty, no filter, no sorting, nothing). received_filter_params = Map . get ( query_params , &quot;filter&quot; , %{ } ) # Trying to get `page` value from user request. By default `DataProvider` already # stay in first page position and configurated for 15 items per page. page = Map . get ( path_params , &quot;page&quot; , 1 ) # * `filter(received_filter_params)` - set new filtering params for current `DataProvider` # and return updated `DataProvider`. # * `change_page(page)` - set new value of page number # * `init()` - accept all of your changes and calculate data in the provider. data_provider = MyDataLoadModule . data_provider ( ) |&gt; filter ( received_filter_params ) |&gt; change_page ( page ) |&gt; init ( ) # Usual rendering function render ( conn , &quot;index.html&quot; , data_provider : data_provider ) end end This is example of using the DataProvider in Phoenix application, what we have done: As you see, definition of MyController.index/2 is typical, we will not stop on it, you can find more information here . I'd only add, that we have declared query_params and path_params variables, they are useful for this example, but it isn't required to. Finally you will got a struct DataProvider , looks like: % DataProvider { module : MyDataLoadModule , data : % DataProvider.Data { total_count : 42 , items : [ ... % Posts { } , % Posts { } , % Posts { } , ... ] } , search_options : % DataProvider.SearchOptions { options : %{ &quot;description&quot; =&gt; &quot;some find string&quot; } , } , sort : % DataProvider.Sort { options : [ ] } pagination : % DataProvider.Pagination { page : 2 , page_size : 15 } } This structure contain all required data for using it in another cases, like an rendering the data table, returning it by REST-full API, live-reload functionality and etc.","ref":"DataProvider.html","title":"DataProvider","type":"module"},{"doc":"Using function of this module macro","ref":"DataProvider.html#__using__/1","title":"DataProvider.__using__/1","type":"macro"},{"doc":"Returns DataProvider with changed page. Args data_provider - DataProvider instance. page - integer value with new page for setting. opts - keyword with function options. Accept values of opts :instant - boolean value. If :instant is true then current data provider will be reloaded instantly, otherwise search params will be loaded with no reloading (for actualizing data provider you will be have to call init/1 ). By default is false .","ref":"DataProvider.html#change_page/3","title":"DataProvider.change_page/3","type":"function"},{"doc":"Function for creating new data provider by search options and module configurations.","ref":"DataProvider.html#create/2","title":"DataProvider.create/2","type":"function"},{"doc":"Add new filter params for data provider Args data_provider - DataProvider instance params - map with new searching params. Value of this argument will be passed into DataProvider.SearchOptions opts - keyword with filtering options. Accept values of opts :merge - boolean value, which affect on new searching options. By default - false, if merge is false - passed searching options will replace search options in exist data provider. If true - will merge. :instant - boolean value. If :instant is true then current data provider will be reloaded instantly, otherwise search params will be loaded with no reloading (for actualizing data provider you will be have to call init/1 ). By default is false .","ref":"DataProvider.html#filter/3","title":"DataProvider.filter/3","type":"function"},{"doc":"Returns DataProvider with loaded new page. This function works similar page/2 with one difference. This function are not wait calling init/1 . Calling the go_to_page/2 reloads data provider right away.","ref":"DataProvider.html#go_to_page/2","title":"DataProvider.go_to_page/2","type":"function"},{"doc":"Initialization function, needs for reload actual state of dataprovider. Calling this function will reload inner data and actualize all inner indexes. This function was separated to independent mechanism for sparingly using a resources.","ref":"DataProvider.html#init/1","title":"DataProvider.init/1","type":"function"},{"doc":"Return current page number of DataProvider","ref":"DataProvider.html#page_number/1","title":"DataProvider.page_number/1","type":"function"},{"doc":"Reloads dataprovider. Required for stateful data providers.","ref":"DataProvider.html#reload/1","title":"DataProvider.reload/1","type":"function"},{"doc":"Add new sorting params for data provider Args data_provider - DataProvider instance params - map with new sorting params. Value of this argument will be passed into DataProvider.Sort opts - keyword with filtering options. Accept values of opts :merge - boolean value, which affect on new searching options. By default - false, if merge is false - passed searching options will replace search options in exist data provider. If true - will merge. :instant - boolean value. If :instant is true then current data provider will be reloaded instantly, otherwise search params will be loaded with no reloading (for actualizing data provider you will be have to call init/1 ). By default is false .","ref":"DataProvider.html#sort/3","title":"DataProvider.sort/3","type":"function"},{"doc":"Type of DataProvider Contains: module - Module atom which implements DataProvider . By default equal :not_implemented . data - DataProvider.Data struct with result of data selection and processing. search_options - struct DataProvider.SearchOptions contains all searching params for exactly this data provider. sort - struct DataProvider.Sort contains all sorting params for exactly this data provider. pagination - DataProvider.Pagination contains state of current of DataProvider and implements all business logic of calculating page sizes, page counts, offsets, limits and etc.","ref":"DataProvider.html#t:t/0","title":"DataProvider.t/0","type":"type"},{"doc":"The data module of DataProvider which result of DataProvider processing In this struct: items - it is a list of result user request","ref":"DataProvider.Data.html","title":"DataProvider.Data","type":"module"},{"doc":"Creates DataProvider.Data struct by received find_result and DataProvider . Args: data_provider - data provider, which been use by user for getting find_result find_result - value, which been returned by find/1 function of user's DataProvider implementation Function will execute behaviour depending on what value was in find_result If received find_result is a Ecto.Query then it will be processed by DataProvider.QueryModifier . The reveived query will be executed and result of execution gonna be put into items of new DataProvider.Data struct. If received find_result is a list() , then it will be processed by DataProvider.ListModifier . The received data will be put into items of new DataProvider.Data struct.","ref":"DataProvider.Data.html#create/2","title":"DataProvider.Data.create/2","type":"function"},{"doc":"DataProvider data value, contains: items - List of found data for exactly this DataProvider total_count - integer value with count of items in items","ref":"DataProvider.Data.html#t:t/0","title":"DataProvider.Data.t/0","type":"type"},{"doc":"Query modificator for DataProvider.Data . Needs DataProvider.Data for changing the Ecto.Query","ref":"DataProvider.Data.QueryModifier.html","title":"DataProvider.Data.QueryModifier","type":"module"},{"doc":"Modify received Ecto.Query by DataProvider in second argument","ref":"DataProvider.Data.QueryModifier.html#modify/2","title":"DataProvider.Data.QueryModifier.modify/2","type":"function"},{"doc":"","ref":"DataProvider.Loader.html","title":"DataProvider.Loader","type":"module"},{"doc":"Loads DataProvider.Data into :data field of DataProvider Receives one argument DataProvider only","ref":"DataProvider.Loader.html#load/1","title":"DataProvider.Loader.load/1","type":"function"},{"doc":"Module, which implements business logic of separation data by pages in DataProvider .","ref":"DataProvider.Pagination.html","title":"DataProvider.Pagination","type":"module"},{"doc":"Creates new DataProvider.Pagination struct with received params. By default, fields will be: page - @default_page page_size - @default_page_size","ref":"DataProvider.Pagination.html#create/1","title":"DataProvider.Pagination.create/1","type":"function"},{"doc":"Calculates end position for received pagination. Requires for calculating selection limit in list of data.","ref":"DataProvider.Pagination.html#end_position/1","title":"DataProvider.Pagination.end_position/1","type":"function"},{"doc":"Returns current page value of DataProvider by DataProvider.Pagination","ref":"DataProvider.Pagination.html#page/1","title":"DataProvider.Pagination.page/1","type":"function"},{"doc":"Returns size of page in current DataProvider.Pagination of DataProvider","ref":"DataProvider.Pagination.html#page_size/1","title":"DataProvider.Pagination.page_size/1","type":"function"},{"doc":"Changes the value of field page","ref":"DataProvider.Pagination.html#put_page/2","title":"DataProvider.Pagination.put_page/2","type":"function"},{"doc":"Changes the value of field page_size","ref":"DataProvider.Pagination.html#put_page_size/2","title":"DataProvider.Pagination.put_page_size/2","type":"function"},{"doc":"Returns count of items, which gonna be put load into DataProvider.Data","ref":"DataProvider.Pagination.html#selection_limit/1","title":"DataProvider.Pagination.selection_limit/1","type":"function"},{"doc":"Calculates starting position for received pagination. Requires for calculating start position in list of data or offset in query condition","ref":"DataProvider.Pagination.html#start_position/1","title":"DataProvider.Pagination.start_position/1","type":"function"},{"doc":"Schema of DataProvider.Pagination . Contains: page - Current page of dataprovider. page_size - count of items in one page of data provider.","ref":"DataProvider.Pagination.html#t:t/0","title":"DataProvider.Pagination.t/0","type":"type"},{"doc":"Module with searching params in DataProvider","ref":"DataProvider.SearchOptions.html","title":"DataProvider.SearchOptions","type":"module"},{"doc":"Creates new DataProvider.SearchOptions with received params","ref":"DataProvider.SearchOptions.html#create/1","title":"DataProvider.SearchOptions.create/1","type":"function"},{"doc":"Merges options value of received DataProvider.SearchOptions with params in second argument. Args search_options - DataProvider.SearchOptions which options need to merge param - Map with new for merging","ref":"DataProvider.SearchOptions.html#merge_options/2","title":"DataProvider.SearchOptions.merge_options/2","type":"function"},{"doc":"Replaces options in DataProvider.SearchOptions by received params map. Args search_options - DataProvider.SearchOptions which options need to replace param - Map with new for replacing","ref":"DataProvider.SearchOptions.html#put_options/2","title":"DataProvider.SearchOptions.put_options/2","type":"function"},{"doc":"Search options Fields options - Map with data searching options for DataProvider","ref":"DataProvider.SearchOptions.html#t:t/0","title":"DataProvider.SearchOptions.t/0","type":"type"},{"doc":"Module with sorting params for DataProvider","ref":"DataProvider.Sort.html","title":"DataProvider.Sort","type":"module"},{"doc":"Creates new DataProvider.Sort with received params","ref":"DataProvider.Sort.html#create/1","title":"DataProvider.Sort.create/1","type":"function"},{"doc":"Merges options value of received DataProvider.Sort with params in second argument. Args sort - DataProvider.Sort which need to merge param - Keyword with new for merging","ref":"DataProvider.Sort.html#merge_options/2","title":"DataProvider.Sort.merge_options/2","type":"function"},{"doc":"Replaces options in DataProvider.Sort by received params map. Args sort - DataProvider.Sort which need to replace param - Keyword with new options for replacing","ref":"DataProvider.Sort.html#put_options/2","title":"DataProvider.Sort.put_options/2","type":"function"},{"doc":"Sort options Fields options - Keyword with data searching options for DataProvider","ref":"DataProvider.Sort.html#t:t/0","title":"DataProvider.Sort.t/0","type":"type"},{"doc":"Raise for Repo.all/2 function calling","ref":"DataProvider.RepoCallError.html","title":"DataProvider.RepoCallError","type":"exception"},{"doc":"Default raise for repo/0 function of users DataProvider implementation","ref":"DataProvider.RepoNotDefinedError.html","title":"DataProvider.RepoNotDefinedError","type":"exception"},{"doc":"Raise for find/1 function calling","ref":"DataProvider.UndefinedFindError.html","title":"DataProvider.UndefinedFindError","type":"exception"}]